ConnectionProvider::FilesystemConnection Class Reference

class for filesystem connections; returns an object of type Qore::Dir; this can be used to monitor filesystem free space or to ensure a network filesystem is mounted, for example More...

Inheritance diagram for ConnectionProvider::FilesystemConnection:
[legend]

## Public Member Functions

| constructor (string name, string desc, string url, bool monitor, *hash opts, hash n_urlh)
| creates the FilesystemConnection object More...
hash | getOptions ()
| gets options More...
string | getType ()
| returns `"dir"`
Public Member Functions inherited from ConnectionProvider::AbstractConnection
| constructor (string n_name, string n_desc, string n_url, bool n_monitor, *hash n_opts, hash n_urlh, *string n_safe_url)
| creates the AbstractConnection object More...
object | get (bool connect=True, *hash rtopts)
| returns the underlying connection object More...
hash< ConfigInfo > | getConfigHash ()
| returns a ConfigInfo hash of static configuration information about the connection More...
*hash | getDefaultOptions ()
| returns default options
hash< ConnectionInfo > | getInfo (bool with_password=False)
| returns a ConnectionInfo hash of information about the connection More...
*hash | getOptions ()
| returns static / initialization options
*hash | getRealOptions ()
| returns options for saving the connection's configuration information
*hash | getRuntimeOptions ()
| returns runtime options
| parseTextOptions ()
| this method is called when parsing connection file definitions from text files when loading into the database More...
hash< PingInfo > | ping (bool throw_exception=False)
| returns a hash with the results of the ping operation More...

## Static Public Member Functions

static FilesystemConnection | make (string name, string desc, string url, bool monitor, *hash opts, hash urlh)
| static constructor

## Public Attributes

const | OptionList = Options.keys()
| FilesystemConnection object connection option list.
const | Options
| FilesystemConnection object connection options.
Public Attributes inherited from ConnectionProvider::AbstractConnection
string | desc
| connection description
date | last_check
| date/time of last check/ping
bool | loopback = False
| set to True for loopback connections
bool | monitor
| monitoring flag
string | name
| connection name
*hash | opts
| connection options
*hash | orig_opts
| original connection options
string | safe_url
| "safe" URL (password information removed)
string | status = "not checked"
| status string; in case of a connection error this string will be the error string
bool | up = False
| connection status flag; set by monitoring or explicit pings/connections
date | updated
| date/time of last update
string | url
| connection URL (potentially with password info)
hash | urlh
| broken down URL hash (as returned by Qore::parse_url())

## Private Member Functions

Dir | getImpl (bool connect=True, *hash rtopts)
| returns a Qore::Dir object More...

## Additional Inherited Members

Static Public Attributes inherited from ConnectionProvider::AbstractConnection
static *code | post_processing
| optional code for default post-processing of objects created by getImpl(); must take the object created and the connection name as arguments

## Detailed Description

class for filesystem connections; returns an object of type Qore::Dir; this can be used to monitor filesystem free space or to ensure a network filesystem is mounted, for example

supports the following option:

- `"readonly"`: does not mark the connection as down if the directory is read-only; use for example if the connection should point to a read-only base directory; interface directories should normally be writable

## Member Function Documentation

## constructor()

ConnectionProvider::FilesystemConnection::constructor | ( | string | name,
|  | string | desc,
|  | string | url,
|  | bool | monitor,
|  | *hash | opts,
|  | hash | n_urlh
| ) |  |

creates the FilesystemConnection object

Parameters

  name | the name of the connection
  desc | connection description
  url | connection URL
  monitor | monitoring flag
  opts | connection options
  n_urlh | broken down URL hash (as returned by Qore::parse_url())

## getImpl()

Dir ConnectionProvider::FilesystemConnection::getImpl | ( | bool | connect = `True`,
|  | *hash | rtopts
| ) |  |

privatevirtual

returns a Qore::Dir object

Parameters

  connect | if True, then the target directory is checked for existence and if it's writable, if either check fails, an exception is thrown
  rtopts | this connection type does not accept any runtime option, so this parameter is ignored

Returns
  a Qore::Dir object

Implements ConnectionProvider::AbstractConnection.

## getOptions()

hash ConnectionProvider::FilesystemConnection::getOptions | ( |  | ) |

gets options

Returns
  returns a hash with the following supported option:
  - `"readonly"`: if True, does not mark the connection as down if the directory is read-only; use for example if the connection should point to a read-only base directory; interface directories should normally be writable (default: False)